VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cIPCMaster"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit    'a generic (StateMachine-based) Class for IPC (Inter-Process-Communication) via SharedMemory
'this Class represents the "Master-Part" (the part, which inits and shells the WorkerProcess)
'Author: Olaf Schmidt (2014)

Private Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Private Type STARTUPINFO
    cb      As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX     As Long
    dwY     As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

'Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Sub RtlMoveMemory Lib "kernel32" (Dst As Any, Src As Any, ByVal bc&)
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
Private Declare Function QueryPerformanceFrequency& Lib "kernel32" (X@)
Private Declare Function QueryPerformanceCounter& Lib "kernel32" (X@)
Private Declare Function CreateProcessW& Lib "kernel32" (ByVal lpApplicationName&, ByVal lpCommandLine&, ByVal lpProcessAttributes&, ByVal lpThreadAttributes&, ByVal bInheritHandles&, ByVal dwCreationFlags&, ByVal lpEnvironment&, ByVal lpCurrentDirectory&, ByVal lpStartupInfo&, ByVal lpProcessInformation&)
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess&, lpExitCode As Long) As Long
Private Declare Function TerminateProcess& Lib "kernel32" (ByVal hProcess&, ByVal uExitCode&)
Private Declare Function CreateFileMappingW& Lib "kernel32" (ByVal hMapFile&, Attr As Any, ByVal Protect&, ByVal SizeHigh&, ByVal SizeLow&, ByVal MapName&)
Private Declare Function MapViewOfFile& Lib "kernel32" (ByVal hMapFile&, ByVal DesAccess&, ByVal OffsHigh&, ByVal OffsLow&, ByVal NumberOfBytesToMap&)
Private Declare Function UnmapViewOfFile& Lib "kernel32" (ByVal lpBaseAddress As Long)
Private Declare Function CloseHandle& Lib "kernel32" (ByVal hObject&)
Private Const PAGE_READWRITE& = &H4, FILE_MAP_ALL_ACCESS& = &HF001F, NORMAL_PRIORITY_CLASS = &H20&

Public Event JobStateChanged(ByVal JobState As eJobState)
Public Event ProgressChanged(ByVal Progress As Single)

'**** don't change the following two defs (similar ones are used in cIPCWorker)
Public Enum eJobState
    jobUndefined = 0     'structure needs initialization
    jobMasterInitialized    'set from the Master-Instance
    jobPrepared          'set from the Master-Instance
    jobCancelled         'set from the Master-Instance
    jobProcessing        'set from the Worker-Instance
    jobFinished          'set from the Worker-Instance
End Enum

Private Type tShared    'a convenience-UDT, sitting at the top of the shared mem-area
    UserDataLen As Long
    MasterHwnd As Long
    JobProgress As Single
    JobPreparedHPSec As Double
    JobStartedHPSec As Double
    JobFinishedHPSec As Double
    JobState As eJobState
End Type
'**** end of shared Based-defs

Private hMapFile&, hProc&, BaseAddr&, T As tShared, WithEvents tmrJobState As VB.Timer
Attribute hProc.VB_VarUserMemId = 1073938432
Attribute BaseAddr.VB_VarUserMemId = 1073938432
Attribute T.VB_VarUserMemId = 1073938432
Attribute tmrJobState.VB_VarHelpID = -1

Public Function InitAndBindWorkerTo(MasterForm As Form, ByVal UserDataLen As Long, ProcessFileName As String) As Long    'returns the ProcessHandle when successful
Attribute InitAndBindWorkerTo.VB_UserMemId = 1610809354
    Dim JobKey$, pInfo As PROCESS_INFORMATION, sInfo As STARTUPINFO

    If BaseAddr Then UnmapViewOfFile BaseAddr: BaseAddr = 0
    If hMapFile Then CloseHandle hMapFile: hMapFile = 0

    'do the Mapping inside the SwapFile
    JobKey = UserDataLen & "_" & App.ThreadID & "_" & ObjPtr(Me)
    hMapFile = CreateFileMappingW(-1, ByVal 0&, PAGE_READWRITE, 0&, LenB(T) + UserDataLen, StrPtr(JobKey))
    If hMapFile Then BaseAddr = MapViewOfFile(hMapFile, FILE_MAP_ALL_ACCESS&, 0&, 0&, 0&)
    If BaseAddr = 0 Then Exit Function

    sInfo.cb = Len(sInfo)
    CreateProcessW 0, StrPtr(ProcessFileName & " " & JobKey), 0, 0, 1, NORMAL_PRIORITY_CLASS, 0, 0, VarPtr(sInfo), VarPtr(pInfo)
    If pInfo.hThread Then CloseHandle pInfo.hThread: hProc = pInfo.hProcess Else Exit Function

    On Error Resume Next
    Set tmrJobState = MasterForm.Controls.Add("VB.Timer", "tmrJobState" & ObjPtr(Me))
    'If tmrJobState Is Nothing Then Exit Function Else tmrJobState.Interval = 7

    If tmrJobState Is Nothing Then 'Error on Line Above
        MasterForm.Controls.Remove "tmrJobState" & ObjPtr(Me)
        Set tmrJobState = MasterForm.Controls.Add("VB.Timer", "tmrJobState" & ObjPtr(Me))
    End If
    tmrJobState.Interval = 7



    On Error GoTo 0

    T.MasterHwnd = MasterForm.hWnd
    T.UserDataLen = UserDataLen
    T.JobState = jobMasterInitialized
    T.JobProgress = 0
    WriteInternalType T
    InitAndBindWorkerTo = hProc    'return the shelled Process-Handle
End Function

Public Sub TerminateWorkerHard()
Attribute TerminateWorkerHard.VB_UserMemId = 1610809355
    If IsWorkerActive Then TerminateProcess hProc, 0: hProc = 0
End Sub
Public Sub CloseWorkerGracefully(Optional ByVal MaxWaitSeconds As Long = 1)
Attribute CloseWorkerGracefully.VB_UserMemId = 1610809356
    If IsWorkerActive And BaseAddr <> 0 Then
        T = ReadInternalType: T.MasterHwnd = 0: WriteInternalType T
        Dim I As Long
        For I = 1 To MaxWaitSeconds * 10
            Wait 100: If Not IsWorkerActive Then Exit For
        Next
    End If
    
End Sub

Public Property Get IsWorkerActive() As Boolean
Attribute IsWorkerActive.VB_UserMemId = 1745027081
    Dim lRet As Long, lStatus As Long
    If hProc Then lRet = GetExitCodeProcess(hProc, lStatus)
    If lRet <> 0 And lStatus = 259 Then IsWorkerActive = True
End Property

Public Property Get JobStateFriendlyName() As String
Attribute JobStateFriendlyName.VB_UserMemId = 1745027080
    If BaseAddr Then JobStateFriendlyName = Choose(JobState + 1, "Undefined", "MasterInitialized", "Prepared", "Cancelled", "Processing", "Finished")
End Property
Public Property Get JobState() As eJobState
Attribute JobState.VB_UserMemId = 1745027079
    If BaseAddr Then JobState = ReadInternalType.JobState
End Property
Public Property Let JobState(ByVal RHS As eJobState)
    If BaseAddr = 0 Then Exit Property
    T = ReadInternalType
    T.JobState = RHS
    If RHS = jobPrepared Then T.JobPreparedHPSec = HPTimer: T.JobProgress = 0
    WriteInternalType T
End Property

Public Property Get JobProgress() As Single
Attribute JobProgress.VB_UserMemId = 1745027078
    If BaseAddr Then JobProgress = ReadInternalType.JobProgress
End Property

Public Property Get JobPreparedHPSec() As Double
Attribute JobPreparedHPSec.VB_UserMemId = 1745027077
    If BaseAddr Then JobPreparedHPSec = ReadInternalType.JobPreparedHPSec
End Property
Public Property Get JobStartedHPSec() As Double
Attribute JobStartedHPSec.VB_UserMemId = 1745027076
    If BaseAddr Then JobStartedHPSec = ReadInternalType.JobStartedHPSec
End Property
Public Property Get JobFinishedHPSec() As Double
Attribute JobFinishedHPSec.VB_UserMemId = 1745027075
    If BaseAddr Then JobFinishedHPSec = ReadInternalType.JobFinishedHPSec
End Property
Public Property Get MasterHwnd() As Long
Attribute MasterHwnd.VB_UserMemId = 1745027074
    If BaseAddr Then MasterHwnd = ReadInternalType.MasterHwnd
End Property

Public Property Get UserDataLen() As Long
Attribute UserDataLen.VB_UserMemId = 1745027073
    If BaseAddr Then UserDataLen = ReadInternalType.UserDataLen
End Property
Public Property Get UserDataPtr() As Long
Attribute UserDataPtr.VB_UserMemId = 1745027072
    If BaseAddr Then UserDataPtr = BaseAddr + LenB(T)
End Property
Public Sub UserDataRead(ByVal pDst As Long, ByVal ByteLen As Long, Optional ByVal Offs As Long)
Attribute UserDataRead.VB_UserMemId = 1610809357
    If BaseAddr Then RtlMoveMemory ByVal pDst, ByVal UserDataPtr + Offs, ByteLen
End Sub
Public Sub UserDataWrite(ByVal pSrc As Long, ByVal ByteLen As Long, Optional ByVal Offs As Long)
Attribute UserDataWrite.VB_UserMemId = 1610809358
    If BaseAddr Then RtlMoveMemory ByVal UserDataPtr + Offs, ByVal pSrc, ByteLen
End Sub

Public Sub Wait(ByVal msec As Long)
Attribute Wait.VB_UserMemId = 1610809359
    Sleep msec: DoEvents
End Sub

Public Function HPTimer#()
Attribute HPTimer.VB_UserMemId = 1610809360
    Dim X@, Frq@
    QueryPerformanceFrequency Frq
    If QueryPerformanceCounter(X) Then HPTimer = X / Frq
End Function

Private Function ReadInternalType() As tShared
    If BaseAddr Then RtlMoveMemory ReadInternalType, ByVal BaseAddr, LenB(ReadInternalType)
End Function
Private Sub WriteInternalType(T As tShared)
    If BaseAddr Then RtlMoveMemory ByVal BaseAddr, T, LenB(T)
End Sub



Private Sub tmrJobState_Timer()

    Static JobState As eJobState, JobPSec#, JobFSec#, Progress!
    T = ReadInternalType
    If JobState <> T.JobState Or JobPSec <> T.JobPreparedHPSec Or JobFSec <> T.JobFinishedHPSec Then
        JobState = T.JobState: JobPSec = T.JobPreparedHPSec: JobFSec = T.JobFinishedHPSec
        RaiseEvent JobStateChanged(JobState)
    End If
    If Progress <> T.JobProgress Then
        Progress = T.JobProgress
        RaiseEvent ProgressChanged(Progress)
    End If
End Sub

Private Sub Class_Terminate()
    TerminateWorkerHard
    If BaseAddr Then UnmapViewOfFile BaseAddr: BaseAddr = 0
    If hMapFile Then CloseHandle hMapFile: hMapFile = 0
End Sub

