Attribute VB_Name = "mDIB"
Option Explicit


Private Type Bitmap
    bmType  As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits  As Long
End Type

Private Declare Function GetObject Lib "gdi32" Alias "GetObjectA" (ByVal hObject As Long, ByVal nCount As Long, ByRef lpObject As Any) As Long
Private Declare Function GetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCOUNT As Long, ByRef lpBits As Any) As Long
Private Declare Function SetBitmapBits Lib "gdi32" (ByVal hBitmap As Long, ByVal dwCOUNT As Long, ByRef lpBits As Any) As Long

'Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (dest As Any, source As Any, ByVal bytes As Long)

Public hBmp As Bitmap

Public pW   As Integer
Public PH   As Integer
Public pB   As Integer

Public OUTBytes() As Byte
Public SourceBytes() As Byte

Private dwCOUNT As Long


Public Sub GetPictureRGBBYTES(PicImageHandle As Long)

    Dim iRet As Long
    'Get the bitmap header
    iRet = GetObject(PicImageHandle, Len(hBmp), hBmp)


    'Resize to hold image data
    ReDim SourceBytes(0 To (hBmp.bmBitsPixel \ 8) - 1, 0 To hBmp.bmWidth - 1, 0 To hBmp.bmHeight - 1) As Byte
    'Get the image data and store into SourceBytes array
    iRet = GetBitmapBits(PicImageHandle, hBmp.bmWidthBytes * hBmp.bmHeight, SourceBytes(0, 0, 0))

    pW = hBmp.bmWidth - 1
    PH = hBmp.bmHeight - 1
    pB = (hBmp.bmBitsPixel \ 8) - 1

    dwCOUNT = hBmp.bmWidthBytes * hBmp.bmHeight

End Sub

Public Sub GetGrayPixels(Inp() As Single)

    Dim X   As Long
    Dim Y   As Long
    Const invers255 As Single = 3.92156862745098E-03
    

    GetPictureRGBBYTES fMain.PIC.Image.Handle

    ReDim Inp(pW, PH)

    For X = 0 To pW
        For Y = 0 To PH
            Inp(X, Y) = (SourceBytes(0, X, Y) * invers255 + _
                         SourceBytes(1, X, Y) * invers255 + _
                         SourceBytes(2, X, Y) * invers255) * 0.333333333333333
        Next
    Next

End Sub

Public Sub GetRGBPixelValues(i1() As Single, i2() As Single, i3() As Single)

    Dim X   As Long
    Dim Y   As Long

    GetPictureRGBBYTES fMain.PIC.Image.Handle

    ReDim i1(pW, PH)
    ReDim i2(pW, PH)
    ReDim i3(pW, PH)

    For X = 0 To pW
        For Y = 0 To PH
            i1(X, Y) = SourceBytes(0, X, Y) / 255
            i2(X, Y) = SourceBytes(1, X, Y) / 255
            i3(X, Y) = SourceBytes(2, X, Y) / 255

        Next
    Next

End Sub
Public Sub Output1ToPIC(pboxImageHandle As Long, V() As Single)
    Dim iRet As Long

    Dim X   As Long
    Dim Y   As Long
    Dim W   As Long
    Dim H   As Long
    Dim VV  As Double

    W = UBound(V, 1)
    H = UBound(V, 2)
    ReDim OUTBytes(pB, W, H)

    For X = 0 To W
        For Y = 0 To H
            VV = V(X, Y)
            If VV < 0 Then VV = 0
            If VV > 1 Then VV = 1
            VV = VV * 255

            OUTBytes(0, X, Y) = VV
            OUTBytes(1, X, Y) = VV
            OUTBytes(2, X, Y) = VV
            OUTBytes(3, X, Y) = 255
        Next
    Next

    hBmp.bmWidth = UBound(OUTBytes, 2) + 1
    hBmp.bmHeight = UBound(OUTBytes, 3) + 1
    hBmp.bmWidthBytes = hBmp.bmWidth * (hBmp.bmBitsPixel \ 8)

    dwCOUNT = hBmp.bmWidthBytes * hBmp.bmHeight

    iRet = SetBitmapBits(pboxImageHandle, dwCOUNT, OUTBytes(0, 0, 0))

End Sub


Public Sub Output3ToPIC(pboxImageHandle As Long, V1() As Single, V2() As Single, V3() As Single)
    Dim iRet As Long

    Dim X   As Long
    Dim Y   As Long
    Dim W   As Long
    Dim H   As Long

    W = UBound(V1, 1)
    H = UBound(V1, 2)
    ReDim OUTBytes(pB, W, H)

    For X = 0 To W
        For Y = 0 To H


            OUTBytes(0, X, Y) = CLAMP01(V1(X, Y)) * 255
            OUTBytes(1, X, Y) = CLAMP01(V2(X, Y)) * 255
            OUTBytes(2, X, Y) = CLAMP01(V3(X, Y)) * 255
            OUTBytes(3, X, Y) = 255
        Next
    Next

    hBmp.bmWidth = UBound(OUTBytes, 2) + 1
    hBmp.bmHeight = UBound(OUTBytes, 3) + 1
    hBmp.bmWidthBytes = hBmp.bmWidth * (hBmp.bmBitsPixel \ 8)

    dwCOUNT = hBmp.bmWidthBytes * hBmp.bmHeight

    iRet = SetBitmapBits(pboxImageHandle, dwCOUNT, OUTBytes(0, 0, 0))

End Sub




Private Function CLAMP01(V As Single) As Single
    CLAMP01 = V
    If CLAMP01 > 1 Then
        CLAMP01 = 1
    ElseIf CLAMP01 < 0 Then
        CLAMP01 = 0
    End If
End Function

