Attribute VB_Name = "mWorker"
Option Explicit

Private Const PI As Single = 3.14159265358979
Private Const PIh As Single = 1.5707963267949
Private Const PI2 As Single = 6.28318530717959
'Private Const InvPI As Single = 1 / 3.14159265358979
'Private Const InvPIh As Single = 1 / 1.5707963267949
'Private Const InvPI2 As Single = 1 / 6.28318530717959


Private WD  As tWorkDATA

Sub Main()
    If Len(Trim$(Command$)) Then EnterWorkerLoop New cIPCWorker, Trim$(Command$)
End Sub

''this routine is called from Sub Main - and generic for cIPCWorker-based Modules (the concrete stuff happens in DoJob below)
'Public Sub EnterWorkerLoop(W As cIPCWorker, JobKey As String)
'
'    If W.InitWithCommandLineJobKey(JobKey) Then
'        Do Until W.MasterWantsToClose
'            If W.WaitForNextPreparedJob Then DoJob W    'do specific Job-Processing
'        Loop
'    End If
'End Sub

'this routine is called from Sub Main - and generic for cIPCWorker-based Modules (the concrete stuff happens in DoJob below)
Public Sub EnterWorkerLoop(W As cIPCWorker, JobKey As String)

    If W.InitWithCommandLineJobKey(JobKey) Then
        Do Until W.MasterWantsToClose
            If W.WaitForNextPreparedJob Then
                ' DoJob W    'do specific Job-Processing

                ' get WD
                W.UserDataRead VarPtr(WD), LenB(WD)

                ' Split JOBS by type-of-Jobs, since each one has his own (Environement)-Varables-Declarations

                Select Case WD.JobType
                    Case 1
                        DoJob_N1 W
                    Case 2
                        DoJob_N2 W
                    Case 3
                        DoJob_N3 W
                    Case 4
                        DoJob_N4 W
                    Case 5
                        DoJob_N5 W
                          Case 6
                        DoJob_N6 W
                End Select
            End If
        Loop
    End If

End Sub



Private Sub DoJob_N1(Worker As cIPCWorker)
'Very Poor Box BLUR algorithm  --- ( never use it ;-) )

    Dim X   As Long
    Dim Y   As Long
    Dim X2  As Long
    Dim Y2  As Long
    Dim Radius As Long
    Dim px  As Long
    Dim py  As Long

    Dim InputArea As Long
    Dim YPart As Long

    Dim vout() As Single
    Dim vIN() As Single

    ReDim vIN(WD.W, WD.H)

    InputArea = (WD.W + 1) * (WD.H + 1) * 4    '(4) for singles

    'Read 2D array input Values
    Worker.UserDataRead VarPtr(vIN(0, 0)), InputArea, LenB(WD)

    '-------------------------------------------------------------------
    'Set up StartY and EndY, Working Area . The values are based on CurrProcess and NProcesses
    YPart = (WD.H + 1) \ WD.NProcesses
    WD.StartY = (WD.CurrProcess - 1) * YPart
    WD.EndY = WD.CurrProcess * YPart - 1
    '  MsgBox "Ypart " & YPart & "  StartY:" & WD.StartY & "  EndY:" & WD.EndY & "   CurrProcess " & WD.CurrProcess & "  NProcesses " & WD.NProcesses
    ReDim vout(WD.W, YPart - 1)
    '-------------------------------------------------------------------


    Radius = WD.JobParams.P(1)

    For Y = WD.StartY To WD.EndY
        For X = 0 To WD.W
            For px = -Radius To Radius
                X2 = X + px:
                If X2 < 0 Then X2 = 0
                If X2 > WD.W Then X2 = WD.W
                For py = -Radius To Radius
                    Y2 = Y + py:
                    If Y2 < 0 Then Y2 = 0
                    If Y2 > WD.H Then Y2 = WD.H
                    vout(X, Y - WD.StartY) = vout(X, Y - WD.StartY) + vIN(X2, Y2)
                Next
            Next
            vout(X, Y - WD.StartY) = vout(X, Y - WD.StartY) / ((Radius * 2 + 1) ^ 2)
        Next
        If Worker.MasterWantsToClose Or Worker.JobState <> wjobProcessing Then Exit Sub    'early exit
    Next


    Worker.UserDataWrite VarPtr(vout(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea
    Worker.UserDataWrite VarPtr(WD), LenB(WD)    '''<<< important be here (Save StartY,EndY)
    Worker.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub


Private Sub DoJob_N2(Worker As cIPCWorker)
' INVERT

    Dim X   As Long
    Dim Y   As Long
    Dim InputArea As Long
    Dim YPart As Long
    Dim vout() As Single
    Dim vIN() As Single

    ReDim vIN(WD.W, WD.H)

    InputArea = (WD.W + 1) * (WD.H + 1) * 4    '(4) for singles

    'Read 2D array input Values
    Worker.UserDataRead VarPtr(vIN(0, 0)), InputArea, LenB(WD)

    '-------------------------------------------------------------------
    'Set up StartY and EndY, Working Area . The values are based on CurrProcess and NProcesses
    YPart = (WD.H + 1) \ WD.NProcesses
    WD.StartY = (WD.CurrProcess - 1) * YPart
    WD.EndY = WD.CurrProcess * YPart - 1
    '  MsgBox "Ypart " & YPart & "  StartY:" & WD.StartY & "  EndY:" & WD.EndY & "   CurrProcess " & WD.CurrProcess & "  NProcesses " & WD.NProcesses
    ReDim vout(WD.W, YPart - 1)
    '-------------------------------------------------------------------


    For Y = WD.StartY To WD.EndY
        For X = 0 To WD.W
            vout(X, Y - WD.StartY) = 1 - vIN(X, Y)
        Next
        If Worker.MasterWantsToClose Or Worker.JobState <> wjobProcessing Then Exit Sub    'early exit
    Next

    Worker.UserDataWrite VarPtr(vout(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea
    Worker.UserDataWrite VarPtr(WD), LenB(WD)    '''<<< important be here (Save StartY,EndY)
    Worker.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub



Private Sub DoJob_N3(Worker As cIPCWorker)
' LENS


    Const NofInputs As Long = 3
    Const NofOutputs As Long = 3

    Dim X   As Long
    Dim Y   As Long
    Dim Xm  As Long
    Dim Ym  As Long
    Dim xP  As Long
    Dim yP  As Long

    Dim InputArea As Long
    Dim OutputArea As Long

    Dim YPart As Long
    Dim Yoffset As Long


    Dim vIN1() As Single
    Dim vIN2() As Single
    Dim vIN3() As Single

    Dim vout1() As Single
    Dim vout2() As Single
    Dim vout3() As Single

    ReDim vIN1(WD.W, WD.H)
    ReDim vIN2(WD.W, WD.H)
    ReDim vIN3(WD.W, WD.H)

    InputArea = (WD.W + 1) * (WD.H + 1) * 4    '(4) for singles
    OutputArea = InputArea \ WD.NProcesses

    'Read 2D array input Values
    Worker.UserDataRead VarPtr(vIN1(0, 0)), InputArea, LenB(WD) + InputArea * 0
    Worker.UserDataRead VarPtr(vIN2(0, 0)), InputArea, LenB(WD) + InputArea * 1
    Worker.UserDataRead VarPtr(vIN3(0, 0)), InputArea, LenB(WD) + InputArea * 2

    '-------------------------------------------------------------------
    'Set up StartY and EndY, Working Area . The values are based on CurrProcess and NProcesses
    YPart = (WD.H + 1) \ WD.NProcesses
    WD.StartY = (WD.CurrProcess - 1) * YPart
    WD.EndY = WD.CurrProcess * YPart - 1
    '  MsgBox "Ypart " & YPart & "  StartY:" & WD.StartY & "  EndY:" & WD.EndY & "   CurrProcess " & WD.CurrProcess & "  NProcesses " & WD.NProcesses
    ReDim vout1(WD.W, YPart - 1)
    ReDim vout2(WD.W, YPart - 1)
    ReDim vout3(WD.W, YPart - 1)

    '-------------------------------------------------------------------
    Yoffset = WD.StartY

    Dim W2  As Single
    Dim H2  As Single
    Dim KW  As Single
    Dim KH  As Single
    Dim dx  As Single
    Dim dy  As Single
    Dim D   As Single
    Dim A   As Single
    Dim D2  As Single
    Dim Strength As Single
    Dim ZOOM As Single
    Dim iZOOM As Single
    Dim W   As Long
    Dim H   As Long


    W = WD.W
    H = WD.H

    Strength = WD.JobParams.P(1) * 0.01

    ZOOM = (Strength) + 1
    iZOOM = 1 / ZOOM
    H2 = (H) / 2
    W2 = (W) / 2
    KW = 1 / (W2)
    KH = 1 / (H2)

    For X = 0 To W
        For Y = WD.StartY To WD.EndY
            dx = (X - W2) * KW
            dy = (Y - H2) * KH

            D = Sqr(dx * dx + dy * dy)
            A = Atan2(dx, dy)

            D2 = D * (1! + Strength * D * D) * iZOOM

            dx = Cos(A) * D2 * W2 + W2
            dy = Sin(A) * D2 * H2 + H2

            If dx >= 0! Then
                If dx <= W Then
                    If dy >= 0! Then
                        If dy <= H Then
                            vout1(X, Y - Yoffset) = vIN1(dx, dy)
                            vout2(X, Y - Yoffset) = vIN2(dx, dy)
                            vout3(X, Y - Yoffset) = vIN3(dx, dy)
                        End If
                    End If
                End If
            End If
        Next
        If Worker.MasterWantsToClose Or Worker.JobState <> wjobProcessing Then Exit Sub    'early exit
    Next

    Worker.UserDataWrite VarPtr(vout1(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs
    Worker.UserDataWrite VarPtr(vout2(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea
    Worker.UserDataWrite VarPtr(vout3(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea * 2

    Worker.UserDataWrite VarPtr(WD), LenB(WD)    '''<<< important be here (Save StartY,EndY)
    Worker.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub


Private Sub DoJob_N4(Worker As cIPCWorker)
' SWAP RGB

    Const NofInputs As Long = 3
    Const NofOutputs As Long = 3

    Dim X   As Long
    Dim Y   As Long

    Dim InputArea As Long
    Dim OutputArea As Long

    Dim YPart As Long
    Dim Yoffset As Long


    Dim vIN1() As Single
    Dim vIN2() As Single
    Dim vIN3() As Single

    Dim vout1() As Single
    Dim vout2() As Single
    Dim vout3() As Single

    ReDim vIN1(WD.W, WD.H)
    ReDim vIN2(WD.W, WD.H)
    ReDim vIN3(WD.W, WD.H)

    InputArea = (WD.W + 1) * (WD.H + 1) * 4    '(4) for singles
    OutputArea = InputArea \ WD.NProcesses

    'Read 2D array input Values
    Worker.UserDataRead VarPtr(vIN1(0, 0)), InputArea, LenB(WD) + InputArea * 0
    Worker.UserDataRead VarPtr(vIN2(0, 0)), InputArea, LenB(WD) + InputArea * 1
    Worker.UserDataRead VarPtr(vIN3(0, 0)), InputArea, LenB(WD) + InputArea * 2

    '-------------------------------------------------------------------
    'Set up StartY and EndY, Working Area . The values are based on CurrProcess and NProcesses
    YPart = (WD.H + 1) \ WD.NProcesses
    WD.StartY = (WD.CurrProcess - 1) * YPart
    WD.EndY = WD.CurrProcess * YPart - 1
    '  MsgBox "Ypart " & YPart & "  StartY:" & WD.StartY & "  EndY:" & WD.EndY & "   CurrProcess " & WD.CurrProcess & "  NProcesses " & WD.NProcesses
    ReDim vout1(WD.W, YPart - 1)
    ReDim vout2(WD.W, YPart - 1)
    ReDim vout3(WD.W, YPart - 1)

    '-------------------------------------------------------------------
    Yoffset = WD.StartY

    For X = 0 To WD.W
        For Y = WD.StartY To WD.EndY

            vout1(X, Y - Yoffset) = vIN2(X, Y)
            vout2(X, Y - Yoffset) = vIN3(X, Y)
            vout3(X, Y - Yoffset) = vIN1(X, Y)

        Next
        If Worker.MasterWantsToClose Or Worker.JobState <> wjobProcessing Then Exit Sub    'early exit
    Next

    Worker.UserDataWrite VarPtr(vout1(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs
    Worker.UserDataWrite VarPtr(vout2(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea
    Worker.UserDataWrite VarPtr(vout3(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea * 2

    Worker.UserDataWrite VarPtr(WD), LenB(WD)    '''<<< important be here (Save StartY,EndY)
    Worker.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub


Private Sub DoJob_N5(Worker As cIPCWorker)
' FLIP

    Const NofInputs As Long = 3
    Const NofOutputs As Long = 3

    Dim X   As Long
    Dim Y   As Long
    Dim W   As Long
    Dim H   As Long


    Dim InputArea As Long
    Dim OutputArea As Long

    Dim YPart As Long
    Dim Yoffset As Long


    Dim vIN1() As Single
    Dim vIN2() As Single
    Dim vIN3() As Single

    Dim vout1() As Single
    Dim vout2() As Single
    Dim vout3() As Single

    ReDim vIN1(WD.W, WD.H)
    ReDim vIN2(WD.W, WD.H)
    ReDim vIN3(WD.W, WD.H)

    InputArea = (WD.W + 1) * (WD.H + 1) * 4    '(4) for singles
    OutputArea = InputArea \ WD.NProcesses

    'Read 2D array input Values
    Worker.UserDataRead VarPtr(vIN1(0, 0)), InputArea, LenB(WD) + InputArea * 0
    Worker.UserDataRead VarPtr(vIN2(0, 0)), InputArea, LenB(WD) + InputArea * 1
    Worker.UserDataRead VarPtr(vIN3(0, 0)), InputArea, LenB(WD) + InputArea * 2

    '-------------------------------------------------------------------
    'Set up StartY and EndY, Working Area . The values are based on CurrProcess and NProcesses
    YPart = (WD.H + 1) \ WD.NProcesses
    WD.StartY = (WD.CurrProcess - 1) * YPart
    WD.EndY = WD.CurrProcess * YPart - 1
    '  MsgBox "Ypart " & YPart & "  StartY:" & WD.StartY & "  EndY:" & WD.EndY & "   CurrProcess " & WD.CurrProcess & "  NProcesses " & WD.NProcesses
    ReDim vout1(WD.W, YPart - 1)
    ReDim vout2(WD.W, YPart - 1)
    ReDim vout3(WD.W, YPart - 1)

    '-------------------------------------------------------------------
    Yoffset = WD.StartY
    W = WD.W
    H = WD.H

    For X = 0 To W
        For Y = WD.StartY To WD.EndY
            vout1(X, Y - Yoffset) = vIN1(W - X, H - Y)
            vout2(X, Y - Yoffset) = vIN2(W - X, H - Y)
            vout3(X, Y - Yoffset) = vIN3(W - X, H - Y)
        Next
        If Worker.MasterWantsToClose Or Worker.JobState <> wjobProcessing Then Exit Sub    'early exit
    Next

    Worker.UserDataWrite VarPtr(vout1(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs
    Worker.UserDataWrite VarPtr(vout2(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea
    Worker.UserDataWrite VarPtr(vout3(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea * 2

    Worker.UserDataWrite VarPtr(WD), LenB(WD)    '''<<< important be here (Save StartY,EndY)
    Worker.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub






Private Sub DoJob_N6(Worker As cIPCWorker)
' EDGES

    Const NofInputs As Long = 3
    Const NofOutputs As Long = 3

    Dim X   As Long
    Dim Y   As Long
    Dim W   As Long
    Dim H   As Long


    Dim InputArea As Long
    Dim OutputArea As Long

    Dim YPart As Long
    Dim Yoffset As Long


    Dim vIN1() As Single
    Dim vIN2() As Single
    Dim vIN3() As Single

    Dim vout1() As Single
    Dim vout2() As Single
    Dim vout3() As Single

    ReDim vIN1(WD.W, WD.H)
    ReDim vIN2(WD.W, WD.H)
    ReDim vIN3(WD.W, WD.H)

    InputArea = (WD.W + 1) * (WD.H + 1) * 4    '(4) for singles
    OutputArea = InputArea \ WD.NProcesses

    'Read 2D array input Values
    Worker.UserDataRead VarPtr(vIN1(0, 0)), InputArea, LenB(WD) + InputArea * 0
    Worker.UserDataRead VarPtr(vIN2(0, 0)), InputArea, LenB(WD) + InputArea * 1
    Worker.UserDataRead VarPtr(vIN3(0, 0)), InputArea, LenB(WD) + InputArea * 2

    '-------------------------------------------------------------------
    'Set up StartY and EndY, Working Area . The values are based on CurrProcess and NProcesses
    YPart = (WD.H + 1) \ WD.NProcesses
    WD.StartY = (WD.CurrProcess - 1) * YPart
    WD.EndY = WD.CurrProcess * YPart - 1
    '  MsgBox "Ypart " & YPart & "  StartY:" & WD.StartY & "  EndY:" & WD.EndY & "   CurrProcess " & WD.CurrProcess & "  NProcesses " & WD.NProcesses
    ReDim vout1(WD.W, YPart - 1)
    ReDim vout2(WD.W, YPart - 1)
    ReDim vout3(WD.W, YPart - 1)

    '-------------------------------------------------------------------
    Yoffset = WD.StartY
    W = WD.W
    H = WD.H
    Dim dx  As Single
    Dim dy  As Single
    Dim xP  As Long
    Dim yP  As Long

    For X = 0 To W
        xP = X + 1: If xP > W Then xP = W
        For Y = WD.StartY To WD.EndY
            yP = Y + 1: If yP > H Then yP = H

            dx = vIN1(X, Y) - vIN1(xP, Y):            dx = Abs(dx)
            dy = vIN1(X, Y) - vIN1(X, yP):            dy = Abs(dy)
            vout1(X, Y - Yoffset) = dx + dy

            dx = vIN2(X, Y) - vIN2(xP, Y):            dx = Abs(dx)
            dy = vIN2(X, Y) - vIN2(X, yP):            dy = Abs(dy)
            vout2(X, Y - Yoffset) = dx + dy

            dx = vIN3(X, Y) - vIN3(xP, Y):            dx = Abs(dx)
            dy = vIN3(X, Y) - vIN3(X, yP):            dy = Abs(dy)
            vout3(X, Y - Yoffset) = dx + dy


        Next
        If Worker.MasterWantsToClose Or Worker.JobState <> wjobProcessing Then Exit Sub    'early exit
    Next

    Worker.UserDataWrite VarPtr(vout1(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs
    Worker.UserDataWrite VarPtr(vout2(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea
    Worker.UserDataWrite VarPtr(vout3(0, 0)), InputArea \ WD.NProcesses, LenB(WD) + InputArea * NofInputs + OutputArea * 2

    Worker.UserDataWrite VarPtr(WD), LenB(WD)    '''<<< important be here (Save StartY,EndY)
    Worker.JobState = wjobFinished    'if the worker-routine reached this point, switch to the next state

End Sub

Private Function Atan2(ByVal X As Single, ByVal Y As Single) As Single
    If X Then
        Atan2 = -PI + Atn(Y / X) - (X > 0!) * PI
    Else
        Atan2 = -PIh - (Y > 0!) * PI
    End If
End Function

Private Function Clamp(V As Single, F As Single, T As Single) As Single
    Clamp = V
    If Clamp < F Then Clamp = F
    If Clamp > T Then Clamp = T
End Function

